#include <iostream>
#include <vector>
using namespace std;
const size_t SCREEN_WIDTH = 80;
const size_t MAX_ASTERISK = SCREEN_WIDTH - 3 - 1;

struct Input {
    vector<double> numbers;
    size_t bin_count{};
};

Input
input_data() {
    size_t number_count;
    cin >> number_count;
    Input in;
    in.numbers.resize(number_count);
    for (size_t i = 0; i < number_count; i++) {
        cin >> in.numbers[i];
    }
    cin >> in.bin_count;
    return in;
}

void
find_minmax(const vector<double>& numbers, double& min, double& max) {
    min = numbers[0];
    max = numbers[0];
    for (size_t x : numbers) {
        if (x < min) {
            min = x;
        }
        else if (x > max) {
            max = x;
        }
    }
    // (    )
}

vector<size_t> make_histogram(const vector<double>& numbers, size_t bin_count){
    vector<size_t> bins(bin_count);
    double min, max;
    find_minmax(numbers, min, max);
    double bin_size = (max-min)/bin_count;
    for (size_t i = 0; i < numbers.size(); i++) {
        bool found = false;
        for (size_t j = 0; (j < bin_count - 1) && !found; j++) {
            auto lo = min + j * bin_size;
            auto hi = min + (j + 1) * bin_size;
            if ( (numbers[i] >= lo) && (numbers[i] < hi) ) {
                bins[j]++;
                found = true;
            }
        }
        if (!found) {
            bins[bin_count-1]++;
        }
    }
    return bins;
}

void
show_histogram_text(vector<size_t> bins){
    size_t max_count = bins[0];
    for(size_t x: bins){
        if(x > max_count){
            max_count = x;
        }
    }
    vector<size_t> heights(bins.size());
    if (max_count>MAX_ASTERISK){
        for (size_t i = 0; i < bins.size(); i++){
            heights[i] = MAX_ASTERISK * (static_cast<double>(bins[i]) /max_count);
        }
    }
    else{
        for (size_t i=0; i<bins.size(); i++){
            heights[i] = bins[i];
        }
    }
    for(size_t i=0; i<bins.size(); i++){
        if (bins[i] < 10){
            cout << "  " << bins[i] << "|";
        }
        else if (bins[i] < 100){
            cout << " " << bins[i] << "|";
        }
        else{
            cout << bins[i] << "|";
        }
        for (size_t j=0; j<heights[i]; j++){
            cout<<"*";
        }
        cout<<"\n";
    }
}

int
main(){
    auto in = input_data();
    auto bins = make_histogram(in.numbers, in.bin_count);
    show_histogram_text(bins);
    return 0;
}
